diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media.inc b/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media.inc
new file mode 100644
index 00000000..a61c7134
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media.inc
@@ -0,0 +1,44 @@
+<?php
+
+/**
+ * @file
+ * Define the WYSIWYG browser plugin.
+ */
+
+/**
+ * Implements WYSIWYG's hook_INCLUDE_plugin().
+ */
+function media_wysiwyg_media_plugin() {
+  // Include the required browser JS.
+  // @todo: wyswiyg should allow libraries and multiple js files
+  // to be defined by this hook.
+  // @see http://drupal.org/node/1039076
+  media_wysiwyg_include_browser_js();
+
+  // Add the filter handling.
+  drupal_add_js(drupal_get_path('module', 'media_wysiwyg') . '/js/media_wysiwyg.filter.js');
+
+  // Plugin definition.
+  $plugins['media'] = array(
+    'title' => variable_get('media_wysiwyg_wysiwyg_title', t('Media browser')),
+    'vendor url' => 'http://drupal.org/project/media',
+    'icon path' => drupal_get_path('module', 'media_wysiwyg') . '/wysiwyg_plugins/media_ckeditor/images',
+    'icon file' => 'icon.gif',
+    'icon title' => variable_get('media_wysiwyg_wysiwyg_icon_title', t('Add media')),
+    // @todo: move this to the plugin directory for the wysiwyg plugin.
+    'js path' => drupal_get_path('module', 'media_wysiwyg') . '/js',
+    'js file' => 'wysiwyg-media.js',
+    'css path' => drupal_get_path('module', 'media_wysiwyg') . '/css',
+    'css file' => 'media_wysiwyg.css',
+    'settings' => array(
+      'global' => array(
+        'enabledPlugins' => variable_get('media_wysiwyg_wysiwyg_browser_plugins', array()),
+        'file_directory' => variable_get('media_wysiwyg_wysiwyg_upload_directory', ''),
+        'types' => variable_get('media_wysiwyg_wysiwyg_allowed_types', array('audio', 'image', 'video', 'document')),
+        'id' => 'media_wysiwyg',
+      ),
+    ),
+  );
+
+  return $plugins;
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media_ckeditor/lang/en.js b/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media_ckeditor/lang/en.js
new file mode 100644
index 00000000..efc1d685
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media_ckeditor/lang/en.js
@@ -0,0 +1,14 @@
+﻿/*
+ Copyright (c) 2003-2013, CKSource - Frederico Knabben. All rights reserved.
+ For licensing, see LICENSE.md or http://ckeditor.com/license
+ */
+CKEDITOR.plugins.setLang( 'media', 'en', {
+  alt: 'Alternative Text',	// Inherit from image plugin.
+  captioned: 'Captioned image', // NEW property.
+  lockRatio: 'Lock Ratio',	// Inherit from image plugin.
+  menu: 'Image Properties',	// Inherit from image plugin.
+  resetSize: 'Reset Size', // Inherit from image plugin.
+  resizer: 'Click and drag to resize',	// NEW property.
+  title: 'Image Properties',	// Inherit from image plugin.
+  urlMissing: 'Image source URL is missing.' // Inherit from image plugin.
+} );
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media_ckeditor/library.js b/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media_ckeditor/library.js
new file mode 100644
index 00000000..a1f33374
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media_ckeditor/library.js
@@ -0,0 +1,183 @@
+
+/**
+ *  @file
+ *  Attach Media ckeditor behaviors.
+ */
+
+(function ($) {
+  Drupal.media = Drupal.media || {};
+
+  Drupal.settings.ckeditor.plugins['media'] = {
+    /**
+     * Execute the button.
+     */
+    invoke: function (data, settings, instanceId) {
+      if (data.format == 'html') {
+        if (jQuery(data.node).is('.media-element')) {
+          // Change the view mode for already-inserted media.
+          var mediaFile = Drupal.media.filter.extract_file_info(jQuery(data.node));
+          Drupal.media.popups.mediaStyleSelector(mediaFile, function (mediaFiles) {
+            Drupal.settings.ckeditor.plugins['media'].insertMediaFile(mediaFile, mediaFiles, CKEDITOR.instances[instanceId]);
+          }, settings['global']);
+        }
+        else {
+          Drupal.media.popups.mediaBrowser(function (mediaFiles) {
+            Drupal.settings.ckeditor.plugins['media'].mediaBrowserOnSelect(mediaFiles, instanceId);
+          }, settings['global']);
+        }
+      }
+    },
+
+    /**
+     * Respond to the mediaBrowser's onSelect event.
+     */
+    mediaBrowserOnSelect: function (mediaFiles, instanceId) {
+      var mediaFile = mediaFiles[0];
+      var options = {};
+      Drupal.media.popups.mediaStyleSelector(mediaFile, function (formattedMedia) {
+        Drupal.settings.ckeditor.plugins['media'].insertMediaFile(mediaFile, formattedMedia, CKEDITOR.instances[instanceId]);
+      }, options);
+
+      return;
+    },
+
+    insertMediaFile: function (mediaFile, formattedMedia, ckeditorInstance) {
+      // Customization of Drupal.media.filter.registerNewElement().
+      var element = Drupal.media.filter.create_element(formattedMedia.html, {
+        fid: mediaFile.fid,
+        view_mode: formattedMedia.type,
+        attributes: formattedMedia.options
+      });
+
+      // Use own wrapper element to be able to properly deal with selections.
+      // Check prepareDataForWysiwygMode() in plugin.js for details.
+      var wysiwygHTML = Drupal.media.filter.getWysiwygHTML(element);
+
+      // Insert element. Use CKEDITOR.dom.element.createFromHtml to ensure our
+      // custom wrapper element is preserved.
+      if (wysiwygHTML.indexOf("<!--MEDIA-WRAPPER-START-") !== -1) {
+        ckeditorInstance.plugins.media.mediaLegacyWrappers = true;
+        wysiwygHTML = wysiwygHTML.replace(/<!--MEDIA-WRAPPER-START-(\d+)-->(.*?)<!--MEDIA-WRAPPER-END-\d+-->/gi, '');
+      } else {
+        wysiwygHTML = '<mediawrapper data="">' + wysiwygHTML + '</mediawrapper>';
+      }
+
+      var editorElement = CKEDITOR.dom.element.createFromHtml(wysiwygHTML);
+      ckeditorInstance.insertElement(editorElement);
+
+      // Initialize widget on our html if possible.
+      if (parseFloat(CKEDITOR.version) >= 4.3 && typeof(CKEDITOR.plugins.registered.widget) != 'undefined') {
+        ckeditorInstance.widgets.initOn( editorElement, 'mediabox' );
+      }
+    },
+
+    /**
+     * Forces custom attributes into the class field of the specified image.
+     *
+     * Due to a bug in some versions of Firefox
+     * (http://forums.mozillazine.org/viewtopic.php?f=9&t=1991855), the
+     * custom attributes used to share information about the image are
+     * being stripped as the image markup is set into the rich text
+     * editor.  Here we encode these attributes into the class field so
+     * the data survives.
+     *
+     * @param imgElement
+     *   The image
+     * @fid
+     *   The file id.
+     * @param view_mode
+     *   The view mode.
+     * @param additional
+     *   Additional attributes to add to the image.
+     */
+    forceAttributesIntoClass: function (imgElement, fid, view_mode, additional) {
+      var wysiwyg = imgElement.attr('wysiwyg');
+      if (wysiwyg) {
+        imgElement.addClass('attr__wysiwyg__' + wysiwyg);
+      }
+      var format = imgElement.attr('format');
+      if (format) {
+        imgElement.addClass('attr__format__' + format);
+      }
+      var typeOf = imgElement.attr('typeof');
+      if (typeOf) {
+        imgElement.addClass('attr__typeof__' + typeOf);
+      }
+      if (fid) {
+        imgElement.addClass('img__fid__' + fid);
+      }
+      if (view_mode) {
+        imgElement.addClass('img__view_mode__' + view_mode);
+      }
+      if (additional) {
+        for (var name in additional) {
+          if (additional.hasOwnProperty(name)) {
+            switch (name) {
+              case 'field_file_image_alt_text[und][0][value]':
+                imgElement.attr('alt', additional[name]);
+                break;
+              case 'field_file_image_title_text[und][0][value]':
+                imgElement.attr('title', additional[name]);
+                break;
+              default:
+                imgElement.addClass('attr__' + name + '__' + additional[name]);
+                break;
+            }
+          }
+        }
+      }
+    },
+
+    /**
+     * Retrieves encoded attributes from the specified class string.
+     *
+     * @param classString
+     *   A string containing the value of the class attribute.
+     * @return
+     *   An array containing the attribute names as keys, and an object
+     *   with the name, value, and attribute type (either 'attr' or
+     *   'img', depending on whether it is an image attribute or should
+     *   be it the attributes section)
+     */
+    getAttributesFromClass: function (classString) {
+      var actualClasses = [];
+      var otherAttributes = [];
+      var classes = classString.split(' ');
+      var regexp = new RegExp('^(attr|img)__([^\S]*)__([^\S]*)$');
+      for (var index = 0; index < classes.length; index++) {
+        var matches = classes[index].match(regexp);
+        if (matches && matches.length === 4) {
+          otherAttributes[matches[2]] = {
+            name: matches[2],
+            value: matches[3],
+            type: matches[1]
+          };
+        }
+        else {
+          actualClasses.push(classes[index]);
+        }
+      }
+      if (actualClasses.length > 0) {
+        otherAttributes['class'] = {
+          name: 'class',
+          value: actualClasses.join(' '),
+          type: 'attr'
+        };
+      }
+      return otherAttributes;
+    },
+
+    sortAttributes: function (a, b) {
+      var nameA = a.name.toLowerCase();
+      var nameB = b.name.toLowerCase();
+      if (nameA < nameB) {
+        return -1;
+      }
+      if (nameA > nameB) {
+        return 1;
+      }
+      return 0;
+    }
+  };
+
+})(jQuery);
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media_ckeditor/plugin.js b/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media_ckeditor/plugin.js
new file mode 100644
index 00000000..37fd3b9d
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/wysiwyg_plugins/media_ckeditor/plugin.js
@@ -0,0 +1,217 @@
+/*
+Copyright (c) 2003-2013, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+*/
+
+/**
+ * @file Plugin for inserting images from Drupal media module
+ *
+ * @TODO Remove all the legecy media wrapper once it's sure nobody uses that
+ * anymore.
+ */
+( function() {
+  var mediaPluginDefinition = {
+    icons: 'media',
+    requires: ['button'],
+    // Check if this instance has widget support. All the default distributions
+    // of the editor have the widget plugin disabled by default.
+    hasWidgetSupport: typeof(CKEDITOR.plugins.registered.widget) != 'undefined',
+    mediaLegacyWrappers: false,
+
+    // Wrap Drupal plugin in a proxy plugin.
+    init: function(editor){
+      editor.addCommand( 'media',
+      {
+        exec: function (editor) {
+          var data = {
+            format: 'html',
+            node: null,
+            content: ''
+          };
+          var selection = editor.getSelection();
+
+          if (selection) {
+            data.node = selection.getSelectedElement();
+            if (data.node) {
+              data.node = data.node.$;
+            }
+            if (selection.getType() == CKEDITOR.SELECTION_TEXT) {
+              if (CKEDITOR.env.ie && CKEDITOR.env.version < 10) {
+                data.content = selection.getNative().createRange().text;
+              }
+              else {
+                data.content = selection.getNative().toString();
+              }
+            }
+            else if (data.node) {
+              // content is supposed to contain the "outerHTML".
+              data.content = data.node.parentNode.innerHTML;
+            }
+          }
+          Drupal.settings.ckeditor.plugins['media'].invoke(data, Drupal.settings.ckeditor.plugins['media'], editor.name);
+        }
+      });
+
+      editor.ui.addButton( 'Media',
+      {
+        label: 'Add media',
+        command: 'media',
+        icon: this.path + 'images/icon.gif'
+      });
+
+      var ckeditorversion = parseFloat(CKEDITOR.version);
+
+      // Because the media comment wrapper don't work well for CKEditor we
+      // replace them by using a custom mediawrapper element.
+      // Instead having
+      // <!--MEDIA-WRAPPER-START-1--><img /><!--MEDIA-WRAPPER-END-1-->
+      // We wrap the placeholder with
+      // <mediawrapper data="1"><img /></mediawrapper>
+      // That way we can deal better with selections - see selectionChange.
+      CKEDITOR.dtd['mediawrapper'] = CKEDITOR.dtd;
+      CKEDITOR.dtd.$blockLimit['mediawrapper'] = 1;
+      CKEDITOR.dtd.$inline['mediawrapper'] = 1;
+      CKEDITOR.dtd.$nonEditable['mediawrapper'] = 1;
+      if (ckeditorversion >= 4.1) {
+        // Register allowed tag for advanced filtering.
+        editor.filter.allow( 'mediawrapper[!data]', 'mediawrapper', true);
+        // Don't remove the data-file_info attribute added by media!
+        editor.filter.allow( '*[!data-file_info]', 'mediawrapper', true);
+        // Ensure image tags accept all kinds of attributes.
+        editor.filter.allow( 'img[*]{*}(*)', 'mediawrapper', true);
+        // Objects should be selected as a whole in the editor.
+        CKEDITOR.dtd.$object['mediawrapper'] = 1;
+      }
+      function prepareDataForWysiwygMode(data) {
+        data = Drupal.media.filter.replaceTokenWithPlaceholder(data);
+        // Legacy media wrapper.
+        mediaPluginDefinition.mediaLegacyWrappers = (data.indexOf("<!--MEDIA-WRAPPER-START-") !== -1);
+        data = data.replace(/<!--MEDIA-WRAPPER-START-(\d+)-->(.*?)<!--MEDIA-WRAPPER-END-\d+-->/gi, '<mediawrapper data="$1">$2</mediawrapper>');
+        return data;
+      }
+      function prepareDataForSourceMode(data) {
+        var replacement = '$2';
+        // Legacy wrapper
+        if (mediaPluginDefinition.mediaLegacyWrappers) {
+          replacement = '<!--MEDIA-WRAPPER-START-$1-->$2<!--MEDIA-WRAPPER-END-$1-->';
+        }
+        data = data.replace(/<mediawrapper data="(.*)">(.*?)<\/mediawrapper>/gi, replacement);
+        data = Drupal.media.filter.replacePlaceholderWithToken(data);
+        return data;
+      }
+
+      // Ensure the tokens are replaced by placeholders while editing.
+      // Check for widget support.
+      if (mediaPluginDefinition.hasWidgetSupport) {
+        editor.widgets.add( 'mediabox',
+        {
+          button: 'Create a mediabox',
+          template: '<mediawrapper></mediawrapper>',
+          editables: {},
+          allowedContent: '*',
+          upcast: function( element ) {
+            if (element.name != 'mediawrapper') {
+              // Ensure media tokens are converted to media placeholdes.
+              element.setHtml(prepareDataForWysiwygMode(element.getHtml()));
+            }
+            return element.name == 'mediawrapper';
+          },
+
+          downcast: function( widgetElement ) {
+            var token = prepareDataForSourceMode(widgetElement.getOuterHtml());
+            return new CKEDITOR.htmlParser.text(token);
+            return element.name == 'mediawrapper';
+          }
+        });
+      }
+      else if (ckeditorversion >= 4) {
+        // CKEditor >=4.0
+        editor.on('setData', function( event ) {
+          event.data.dataValue = prepareDataForWysiwygMode(event.data.dataValue);
+        });
+      }
+      else {
+        // CKEditor >=3.6 behaviour.
+        editor.on( 'beforeSetMode', function( event, data ) {
+          event.removeListener();
+          var wysiwyg = editor._.modes[ 'wysiwyg' ];
+          var source = editor._.modes[ 'source' ];
+          wysiwyg.loadData = CKEDITOR.tools.override( wysiwyg.loadData, function( org )
+          {
+            return function( data ) {
+              return ( org.call( this, prepareDataForWysiwygMode(data)) );
+            };
+          } );
+          source.loadData = CKEDITOR.tools.override( source.loadData, function( org )
+          {
+            return function( data ) {
+              return ( org.call( this, prepareDataForSourceMode(data) ) );
+            };
+          } );
+        });
+      }
+
+      // Provide alternative to the widget functionality introduced in 4.3.
+      if (!mediaPluginDefinition.hasWidgetSupport) {
+        // Ensure tokens instead the html element is saved.
+        editor.on('getData', function( event ) {
+          event.data.dataValue = prepareDataForSourceMode(event.data.dataValue);
+        });
+
+        // Ensure our enclosing wrappers are always included in the selection.
+        editor.on('selectionChange', function( event ) {
+          var ranges = editor.getSelection().getRanges().createIterator();
+          var newRanges = [];
+          var currRange;
+          while(currRange = ranges.getNextRange()) {
+            var commonAncestor = currRange.getCommonAncestor(false);
+            if (commonAncestor && typeof(commonAncestor.getName) != 'undefined' && commonAncestor.getName() == 'mediawrapper') {
+              var range = new CKEDITOR.dom.range( editor.document );
+              if (currRange.collapsed === true) {
+                // Don't allow selection within the wrapper element.
+                if (currRange.startOffset == 0) {
+                  // While v3 plays nice with setting start and end to avoid
+                  // editing within the media wrapper element, v4 ignores that.
+                  // Thus we try to move the cursor further away.
+                  if (parseInt(CKEDITOR.version) > 3) {
+                    range.setStart(commonAncestor.getPrevious());
+                    range.setEnd(commonAncestor.getPrevious());
+                  }
+                  else {
+                    range.setStartBefore(commonAncestor);
+                  }
+                }
+                else {
+                  // While v3 plays nice with setting start and end to avoid
+                  // editing within the media wrapper element, v4 ignores that.
+                  // Thus we try to move the cursor further away.
+                  if (parseInt(CKEDITOR.version) > 3) {
+                    range.setStart(commonAncestor.getNext(), 1);
+                    range.setEnd(commonAncestor.getNext(), 1);
+                  }
+                  else {
+                    range.setStartAfter(commonAncestor);
+                  }
+                }
+              }
+              else {
+                // Always select the whole wrapper element.
+                range.setStartBefore(commonAncestor);
+                range.setEndAfter(commonAncestor);
+              }
+              newRanges.push(range);
+            }
+          }
+          if (newRanges.length) {
+            editor.getSelection().selectRanges(newRanges);
+          }
+        });
+      }
+    }
+  };
+  // Add dependency to widget plugin if possible.
+  if (parseFloat(CKEDITOR.version) >= 4.3 && mediaPluginDefinition.hasWidgetSupport) {
+    mediaPluginDefinition.requires.push('widget');
+  }
+  CKEDITOR.plugins.add( 'media', mediaPluginDefinition);
+} )();
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg_view_mode/media_wysiwyg_view_mode.info b/drupal7/sites/all/modules/media/modules/media_wysiwyg_view_mode/media_wysiwyg_view_mode.info
index e026c8f2..765a7a17 100644
--- a/drupal7/sites/all/modules/media/modules/media_wysiwyg_view_mode/media_wysiwyg_view_mode.info
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg_view_mode/media_wysiwyg_view_mode.info
@@ -3,14 +3,15 @@ description = Enables files inside of the WYSIWYG editor to be displayed using a
 package = Media
 core = 7.x
 
-dependencies[] = media
-dependencies[] = wysiwyg
+dependencies[] = media_wysiwyg
 
 configure = admin/config/media/wysiwyg-view-mode
 
-; Information added by drupal.org packaging script on 2013-10-25
-version = "7.x-2.0-alpha3"
+files[] = media_wysiwyg_view_mode.test
+
+; Information added by Drupal.org packaging script on 2014-10-04
+version = "7.x-2.0-alpha4"
 core = "7.x"
 project = "media"
-datestamp = "1382744872"
+datestamp = "1412422430"
 
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg_view_mode/media_wysiwyg_view_mode.module b/drupal7/sites/all/modules/media/modules/media_wysiwyg_view_mode/media_wysiwyg_view_mode.module
index bd9231d0..d36bec71 100644
--- a/drupal7/sites/all/modules/media/modules/media_wysiwyg_view_mode/media_wysiwyg_view_mode.module
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg_view_mode/media_wysiwyg_view_mode.module
@@ -58,9 +58,9 @@ function media_wysiwyg_view_mode_entity_info_alter(&$entity_info) {
 }
 
 /**
- * Implements hook_media_wysiwyg_allowed_view_modes_alter().
+ * Implements hook_media_wysiwyg_wysiwyg_allowed_view_modes_alter().
  */
-function media_wysiwyg_view_mode_media_wysiwyg_allowed_view_modes_alter(&$view_modes, &$file) {
+function media_wysiwyg_view_mode_media_wysiwyg_wysiwyg_allowed_view_modes_alter(&$view_modes, &$file) {
   if (variable_get("media_wysiwyg_view_mode_{$file->type}_wysiwyg_restricted_view_modes_status", FALSE) == TRUE) {
     $restricted_view_modes = variable_get("media_wysiwyg_view_mode_{$file->type}_wysiwyg_restricted_view_modes", array());
 
@@ -73,17 +73,17 @@ function media_wysiwyg_view_mode_media_wysiwyg_allowed_view_modes_alter(&$view_m
 }
 
 /**
- * Implements hook_media_token_to_markup_alter().
+ * Implements hook_media_wysiwyg_token_to_markup_alter().
  */
-function media_wysiwyg_view_mode_media_token_to_markup_alter(&$element, $tag_info, $settings) {
+function media_wysiwyg_view_mode_media_wysiwyg_token_to_markup_alter(&$element, $tag_info, $settings) {
   if (!empty($settings['wysiwyg'])) {
     $file = $tag_info['file'];
 
     if (variable_get("media_wysiwyg_view_mode_{$file->type}_file_wysiwyg_view_mode_status", FALSE) == TRUE) {
-      $element = media_get_file_without_label($file, variable_get("media_wysiwyg_view_mode_{$file->type}_file_wysiwyg_view_mode", 'wysiwyg'), $settings);
+      $element = media_wysiwyg_get_file_without_label($file, variable_get("media_wysiwyg_view_mode_{$file->type}_file_wysiwyg_view_mode", 'wysiwyg'), $settings);
     }
     else {
-      $element = media_get_file_without_label($file, $tag_info['view_mode'], $settings);
+      $element = media_wysiwyg_get_file_without_label($file, $tag_info['view_mode'], $settings);
     }
   }
 }
@@ -93,12 +93,27 @@ function media_wysiwyg_view_mode_media_token_to_markup_alter(&$element, $tag_inf
  */
 function media_wysiwyg_view_mode_form_alter(&$form, $form_state, $form_id)  {
   switch ($form_id)  {
-    case 'media_format_form':
-      $file = $form['#media'];
+    case 'media_wysiwyg_format_form':
+      $file = $form_state['file'];
 
-      $default_view_mode = variable_get('media__wysiwyg_default_view_mode', 'full');
-
-      $view_mode = !empty($form_state['values']['format']) ? $form_state['values']['format'] : $default_view_mode;
+      // Check to see if a view mode ("format") has already been specified for
+      //  this media item. First, check for a standard form-submitted value.
+      if (!empty($form_state['values']['format'])) {
+        $view_mode = $form_state['values']['format'];
+      }
+      // Second, check the request for a JSON-encoded value.
+      elseif (isset($_GET['fields'])) {
+        $query_fields = drupal_json_decode($_GET['fields']);
+        if (isset($query_fields['format'])) {
+          $view_mode = $query_fields['format'];
+        }
+      }
+      // If we were unable to determine a view mode, or we found a view mode
+      //  that does not exist in the list of format options presented on this
+      //  form, use the default view mode.
+      if (!isset($view_mode) || !array_key_exists($view_mode, $form['options']['format']['#options'])) {
+        $view_mode = variable_get('media_wysiwyg_wysiwyg_default_view_mode', 'full');
+      }
 
       $form['preview'] = file_view_file($file, $view_mode);
       $form['preview']['#prefix'] = '<div id="preview">';
@@ -112,17 +127,17 @@ function media_wysiwyg_view_mode_form_alter(&$form, $form_state, $form_id)  {
         'wrapper' => 'preview',
       );
 
-      $view_modes = media_get_wysiwyg_allowed_view_modes($file);
+      $view_modes = media_wysiwyg_get_wysiwyg_allowed_view_modes($file);
       $formats = $options = array();
       foreach ($view_modes as $view_mode => $view_mode_info) {
         //@TODO: Display more verbose information about which formatter and what it does.
         $options[$view_mode] = $view_mode_info['label'];
 
         if (variable_get("media_wysiwyg_view_mode_{$file->type}_file_wysiwyg_view_mode_status", FALSE) == TRUE) {
-          $element = media_get_file_without_label($file, variable_get("media_wysiwyg_view_mode_{$file->type}_file_wysiwyg_view_mode", 'wysiwyg'), array('wysiwyg' => TRUE));
+          $element = media_wysiwyg_get_file_without_label($file, variable_get("media_wysiwyg_view_mode_{$file->type}_file_wysiwyg_view_mode", 'wysiwyg'), array('wysiwyg' => TRUE));
         }
         else {
-          $element = media_get_file_without_label($file, $view_mode, array('wysiwyg' => TRUE));
+          $element = media_wysiwyg_get_file_without_label($file, $view_mode, array('wysiwyg' => TRUE));
         }
 
         // Make a pretty name out of this.
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg_view_mode/media_wysiwyg_view_mode.test b/drupal7/sites/all/modules/media/modules/media_wysiwyg_view_mode/media_wysiwyg_view_mode.test
new file mode 100644
index 00000000..a51dc2fa
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg_view_mode/media_wysiwyg_view_mode.test
@@ -0,0 +1,65 @@
+<?php
+
+/**
+ * @file
+ * Tests for media_wysiwyg_view_mode.module.
+ */
+
+/**
+ * Defines base class for media_wysiwyg_view_mode test cases.
+ */
+class MediaWYSIWYGViewModeTestHelper extends MediaWYSIWYGTestHelper {
+  function setUp() {
+    parent::setUp('media_wysiwyg_view_mode');
+
+    $web_user = $this->drupalCreateUser(array('administer media wysiwyg view mode', 'view files'));
+    $this->drupalLogin($web_user);
+  }
+}
+
+/**
+ * Test configuring view modes available on the format form.
+ */
+class FormatFormViewModesTest extends MediaWYSIWYGViewModeTestHelper {
+  public static function getInfo() {
+    return array(
+      'name' => 'Format Form WYSIWYG View Modes',
+      'description' => 'Test configuring view modes available on the format form.',
+      'group' => 'Media WYSIWYG View Mode',
+    );
+  }
+
+  function setUp() {
+    parent::setUp();
+  }
+
+  /**
+   * Configure format form view mode restrictions and ensure that they are followed.
+   */
+  function testAllowedFormatFormViewModes() {
+    // Load the Media WYSIWYG View Mode administration page.
+    $this->drupalGet('admin/config/media/wysiwyg-view-mode');
+    $this->assertResponse(200, t('The privileged user can access the Media WYSIWYG View Mode administration page.'));
+
+    // Create an image file to test with.
+    $files = $this->drupalGetTestFiles('image');
+    $files[0]->status = FILE_STATUS_PERMANENT;
+    $file = file_save($files[0]);
+    $fid = $file->fid;
+
+    // The default view mode should be selected by default.
+    $this->drupalGet('media/' . $fid . '/format-form');
+    $this->assertOptionSelected('edit-format', 'default');
+
+    // Restrict the use of the default view mode.
+    variable_set('media_wysiwyg_view_mode_image_wysiwyg_restricted_view_modes_status', TRUE);
+    $restricted_view_modes = array(
+      'default' => 'default',
+    );
+    variable_set('media_wysiwyg_view_mode_image_wysiwyg_restricted_view_modes', $restricted_view_modes);
+
+    // The teaser view mode should now be selected by default.
+    $this->drupalGet('media/' . $fid . '/format-form');
+    $this->assertOptionSelected('edit-format', 'teaser');
+  }
+}
diff --git a/drupal7/sites/all/modules/media/modules/mediafield/mediafield.info b/drupal7/sites/all/modules/media/modules/mediafield/mediafield.info
index a79d9df9..ed00075c 100644
--- a/drupal7/sites/all/modules/media/modules/mediafield/mediafield.info
+++ b/drupal7/sites/all/modules/media/modules/mediafield/mediafield.info
@@ -4,9 +4,9 @@ package = Media
 core = 7.x
 dependencies[] = media
 
-; Information added by drupal.org packaging script on 2013-10-25
-version = "7.x-2.0-alpha3"
+; Information added by Drupal.org packaging script on 2014-10-04
+version = "7.x-2.0-alpha4"
 core = "7.x"
 project = "media"
-datestamp = "1382744872"
+datestamp = "1412422430"
 
